## ignition-transport 1.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8 FATAL_ERROR)

set(IGN_PROJECT_NAME "transport")

project (ignition-${IGN_PROJECT_NAME})
string (TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)
string (TOUPPER ${PROJECT_NAME} PROJECT_NAME_UPPER)

set (PROJECT_MAJOR_VERSION 1)
set (PROJECT_MINOR_VERSION 3)
set (PROJECT_PATCH_VERSION 0)

set (PROJECT_VERSION ${PROJECT_MAJOR_VERSION}.${PROJECT_MINOR_VERSION})
set (PROJECT_VERSION_FULL ${PROJECT_MAJOR_VERSION}.${PROJECT_MINOR_VERSION}.${PROJECT_PATCH_VERSION})

message (STATUS "${PROJECT_NAME} version ${PROJECT_VERSION_FULL}")

set (project_cmake_dir ${PROJECT_SOURCE_DIR}/cmake
  CACHE PATH "Location of CMake scripts")

include (${project_cmake_dir}/Utils.cmake)

##########
# Package Creation:

# If on windows, generate a file called version which host the current
# version to be used by releasing scripts
if (MSVC)
  file(WRITE ${PROJECT_BINARY_DIR}/VERSION ${PROJECT_VERSION_FULL})
endif()

include (${project_cmake_dir}/cpack.cmake)
set (CPACK_PACKAGE_VERSION "${PROJECT_VERSION_FULL}")
set (CPACK_PACKAGE_VERSION_MAJOR "${PROJECT_MAJOR_VERSION}")
set (CPACK_PACKAGE_VERSION_MINOR "${PROJECT_MINOR_VERSION}")
set (CPACK_PACKAGE_VERSION_PATCH "${PROJECT_PATCH_VERSION}")

if (CPACK_GENERATOR)
  message(STATUS "Found CPack generators: ${CPACK_GENERATOR}")

  configure_file("${project_cmake_dir}/cpack_options.cmake.in"
    ${PROJECT_CPACK_CFG_FILE} @ONLY)

  set(CPACK_PROJECT_CONFIG_FILE ${PROJECT_CPACK_CFG_FILE})
  include (CPack)
endif()

# If we're configuring only to package source, stop here
if (PACKAGE_SOURCE_ONLY)
  message(WARNING "Configuration was done in PACKAGE_SOURCE_ONLY mode."
  "You can build a tarball (make package_source), but nothing else.")
  return()
endif()

# Fix path format (if variables are specified).
# On windows this will replace backslashes with forward slashes
if (ZeroMQ_ROOT_DIR)
  file(TO_CMAKE_PATH ${ZeroMQ_ROOT_DIR} ZeroMQ_ROOT_DIR)
endif()
if (CPPZMQ_HEADER_PATH)
  file(TO_CMAKE_PATH ${CPPZMQ_HEADER_PATH} CPPZMQ_HEADER_PATH)
endif()

#################################################
# Documentation:
add_subdirectory(doc)

# Configure documentation uploader
configure_file("${project_cmake_dir}/upload_doc.sh.in"
  ${CMAKE_BINARY_DIR}/upload_doc.sh @ONLY)

# If we're configuring only to build docs, stop here
if (DOC_ONLY)
  message(WARNING "Configuration was done in DOC_ONLY mode."
  " You can build documentation (make doc), but nothing else.")
  return()
endif()

enable_testing()

# Use GNUInstallDirst to get canonical paths
include(GNUInstallDirs)

# with -fPIC
if(UNIX AND NOT WIN32)
  set (CMAKE_INSTALL_PREFIX "/usr" CACHE STRING "Install Prefix")
 find_program(CMAKE_UNAME uname /bin /usr/bin /usr/local/bin )
 if(CMAKE_UNAME)
   exec_program(uname ARGS -m OUTPUT_VARIABLE CMAKE_SYSTEM_PROCESSOR)
   set(CMAKE_SYSTEM_PROCESSOR ${CMAKE_SYSTEM_PROCESSOR} CACHE INTERNAL
     "processor type (i386 and x86_64)")
   if(CMAKE_SYSTEM_PROCESSOR MATCHES "x86_64")
     ADD_DEFINITIONS(-fPIC)
   endif(CMAKE_SYSTEM_PROCESSOR MATCHES "x86_64")
 endif(CMAKE_UNAME)
endif()

set (CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE ON)

# developer's option to cache PKG_CONFIG_PATH and
# LD_LIBRARY_PATH for local installs
if(PKG_CONFIG_PATH)
  set (ENV{PKG_CONFIG_PATH} ${PKG_CONFIG_PATH}:$ENV{PKG_CONFIG_PATH})
endif()
if(LD_LIBRARY_PATH)
  set (ENV{LD_LIBRARY_PATH} ${LD_LIBRARY_PATH}:$ENV{LD_LIBRARY_PATH})
endif()


set (INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_INCLUDEDIR}/ignition")
set (LIB_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR})
set (BIN_INSTALL_DIR ${CMAKE_INSTALL_BINDIR})

set (USE_FULL_RPATH OFF CACHE BOOL "Set to true to enable full rpath")

if (USE_FULL_RPATH)
  # use, i.e. don't skip the full RPATH for the build tree
  set(CMAKE_SKIP_BUILD_RPATH  FALSE)

  # when building, don't use the install RPATH already
  # (but later on when installing)
  set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)

  set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}")

  # add the automatically determined parts of the RPATH
  # which point to directories outside the build tree to the install RPATH
  set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

  # the RPATH to be used when installing, but only if its not a system directory
  list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}" isSystemDir)
  if("${isSystemDir}" STREQUAL "-1")
    set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}")
  endif("${isSystemDir}" STREQUAL "-1")
endif()

set (BUILD_IGNITION ON CACHE INTERNAL
  "Build Ignition ${IGN_PROJECT_NAME}" FORCE)
set (build_errors "" CACHE INTERNAL "build errors" FORCE)
set (build_warnings "" CACHE INTERNAL "build warnings" FORCE)

include (${project_cmake_dir}/DissectVersion.cmake)

message (STATUS "\n\n====== Finding 3rd Party Packages ======")
include (${project_cmake_dir}/SearchForStuff.cmake)
message (STATUS "----------------------------------------\n")

#####################################
MESSAGE(STATUS "Checking ignition build type")
# Set the default build type
if (NOT CMAKE_BUILD_TYPE)
    set (CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING
        "Choose the type of build, options are: Debug Release RelWithDebInfo Profile Check" FORCE)
endif (NOT CMAKE_BUILD_TYPE)
# TODO: still convert to uppercase to keep backwards compatibility with
# uppercase old supported and deprecated modes
string(TOUPPER ${CMAKE_BUILD_TYPE} CMAKE_BUILD_TYPE_UPPERCASE)

set (BUILD_TYPE_PROFILE FALSE)
set (BUILD_TYPE_RELEASE FALSE)
set (BUILD_TYPE_RELWITHDEBINFO FALSE)
set (BUILD_TYPE_DEBUG FALSE)

if ("${CMAKE_BUILD_TYPE_UPPERCASE}" STREQUAL "PROFILE")
  set (BUILD_TYPE_PROFILE TRUE)
elseif ("${CMAKE_BUILD_TYPE_UPPERCASE}" STREQUAL "RELEASE")
  set (BUILD_TYPE_RELEASE TRUE)
elseif ("${CMAKE_BUILD_TYPE_UPPERCASE}" STREQUAL "RELWITHDEBINFO")
  set (BUILD_TYPE_RELWITHDEBINFO TRUE)
elseif ("${CMAKE_BUILD_TYPE_UPPERCASE}" STREQUAL "DEBUG")
  set (BUILD_TYPE_DEBUG TRUE)
elseif ("${CMAKE_BUILD_TYPE_UPPERCASE}" STREQUAL "COVERAGE")
  include (${project_cmake_dir}/CodeCoverage.cmake)
  set (BUILD_TYPE_DEBUG TRUE)
  SETUP_TARGET_FOR_COVERAGE(coverage ctest coverage)
else()
  build_error("CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} unknown. Valid options are: Debug Release RelWithDebInfo Profile Check")
endif()

#####################################
# Handle CFlags
unset (CMAKE_C_FLAGS_ALL CACHE)
unset (CMAKE_CXX_FLAGS CACHE)

# USE_HOST_CFLAGS (default TRUE)
# Will check building host machine for proper cflags
if(NOT DEFINED USE_HOST_CFLAGS OR USE_HOST_CFLAGS)
  message(STATUS "Enable host CFlags")
  include (${project_cmake_dir}/HostCFlags.cmake)
endif()

# USE_UPSTREAM_CFLAGS (default TRUE)
# Will use predefined ignition developers cflags
if(NOT DEFINED USE_UPSTREAM_CFLAGS OR USE_UPSTREAM_CFLAGS)
  message(STATUS "Enable upstream CFlags")
  include(${project_cmake_dir}/DefaultCFlags.cmake)
endif()

# Check if warning options are avaliable for the compiler and return WARNING_CXX_FLAGS variable
if (MSVC)
  set(WARN_LEVEL "/W4")

  # Unable to be filtered flags (failing due to limitations in filter_valid_compiler_warnings)
  # Handling exceptions rightly and ignore unknown pragmas
  set(UNFILTERED_FLAGS "/EHsc /wd4068")
else()
  # Equivalent to Wall (according to man gcc) but removed the unknown pragmas since we use
  # MSVC only pragmas all over the code
  list(APPEND WARN_LEVEL -Waddress -Warray-bounds -Wcomment -Wformat -Wnonnull)
  list(APPEND WARN_LEVEL -Wparentheses -Wreorder -Wreturn-type)
  list(APPEND WARN_LEVEL -Wsequence-point -Wsign-compare -Wstrict-aliasing)
  list(APPEND WARN_LEVEL -Wstrict-overflow=1 -Wswitch -Wtrigraphs -Wuninitialized)
  list(APPEND WARN_LEVEL -Wunused-function -Wunused-label -Wunused-value)
  list(APPEND WARN_LEVEL -Wunused-variable -Wvolatile-register-var)

  # Unable to be filtered flags (failing due to limitations in filter_valid_compiler_warnings)
  set(UNFILTERED_FLAGS "-Wc++11-compat")
endif()

filter_valid_compiler_warnings(${WARN_LEVEL} -Wextra -Wno-long-long
  -Wno-unused-value -Wno-unused-value -Wno-unused-value -Wno-unused-value
  -Wfloat-equal -Wshadow -Winit-self -Wswitch-default
  -Wmissing-include-dirs -pedantic -Wno-pragmas)
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}${WARNING_CXX_FLAGS} ${UNFILTERED_FLAGS}")

#################################################
# OS Specific initialization
if (UNIX)
  ign_setup_unix()
else (WIN32)
  ign_setup_windows()
endif()

if(APPLE)
  ign_setup_apple()
endif()

#################################################
# Print warnings and errors
if ( build_warnings )
  message(STATUS "BUILD WARNINGS")
  foreach (msg ${build_warnings})
    message(STATUS ${msg})
  endforeach ()
  message(STATUS "END BUILD WARNINGS\n")
endif (build_warnings)

########### Add uninstall target ###############
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)
add_custom_target(uninstall
  "${CMAKE_COMMAND}" -P
  "${CMAKE_CURRENT_BINARY_DIR}/cmake/cmake_uninstall.cmake")

if (build_errors)
  message(STATUS "BUILD ERRORS: These must be resolved before compiling.")
  foreach (msg ${build_errors})
    message(STATUS ${msg})
  endforeach ()
  message(STATUS "END BUILD ERRORS\n")
  message (FATAL_ERROR "Errors encountered in build. "
      "Please see the BUILD ERRORS above.")
else (build_errors)

  ########################################
  # Write the config.hh file
  configure_file (${project_cmake_dir}/config.hh.in
    ${PROJECT_BINARY_DIR}/include/ignition/${IGN_PROJECT_NAME}/config.hh)
  ign_install_includes(
    ${IGN_PROJECT_NAME}${PROJECT_MAJOR_VERSION}/ignition/${IGN_PROJECT_NAME}
    ${PROJECT_BINARY_DIR}/include/ignition/${IGN_PROJECT_NAME}/config.hh)

  include_directories(
    ${PROJECT_SOURCE_DIR}/include
    ${PROJECT_BINARY_DIR}/include
  )
  link_directories(${PROJECT_BINARY_DIR}/src)

  if (DEFINED CMAKE_CXX_FLAGS)
    message (STATUS "Custom CFlags:${CMAKE_CXX_FLAGS}")
  else()
    message (STATUS "Use default CFlags")
  endif()
  message (STATUS "Build Type: ${CMAKE_BUILD_TYPE}")
  message (STATUS "Install path: ${CMAKE_INSTALL_PREFIX}")

  if (BUILD_IGNITION)
    set(TEST_TYPE "UNIT")
    add_subdirectory(msgs)
    add_subdirectory(src)
    add_subdirectory(include)
    add_subdirectory(conf)
    add_subdirectory(tools)
    add_subdirectory(test)
  endif (BUILD_IGNITION)

  ########################################
  # Make the package config files
  set (pkgconfig_files ${PROJECT_NAME_LOWER})

  foreach (pkgconfig ${pkgconfig_files})
    configure_file(${CMAKE_SOURCE_DIR}/cmake/pkgconfig/${pkgconfig}.in
      ${CMAKE_CURRENT_BINARY_DIR}/cmake/pkgconfig/${pkgconfig}${PROJECT_MAJOR_VERSION}.pc @ONLY)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/cmake/pkgconfig/${pkgconfig}${PROJECT_MAJOR_VERSION}.pc
      DESTINATION ${LIB_INSTALL_DIR}/pkgconfig COMPONENT pkgconfig)
  endforeach()

  ########################################
  # Make the cmake config files
  set(PKG_NAME ${PROJECT_NAME_UPPER})
  set(PKG_LIBRARIES ${PROJECT_NAME_LOWER}${PROJECT_MAJOR_VERSION})
  set(cmake_conf_file "${PROJECT_NAME_LOWER}${PROJECT_MAJOR_VERSION}-config.cmake")
  set(cmake_conf_version_file "${PROJECT_NAME_LOWER}${PROJECT_MAJOR_VERSION}-config-version.cmake")

  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/ignition-config.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/${cmake_conf_file}" @ONLY)

  # Use write_basic_package_version_file to generate a ConfigVersion file that
  # allow users of gazebo to specify the API or version to depend on
  # TODO: keep this instruction until deprecate Ubuntu/Precise and update with
  # https://github.com/Kitware/CMake/blob/v2.8.8/Modules/CMakePackageConfigHelpers.cmake
  include(WriteBasicConfigVersionFile)
  write_basic_config_version_file(
    ${CMAKE_CURRENT_BINARY_DIR}/${cmake_conf_version_file}
    VERSION "${PROJECT_VERSION_FULL}"
    COMPATIBILITY SameMajorVersion)

  install(FILES

=== conf/CMakeLists.txt ===
include (${project_cmake_dir}/Utils.cmake)

set(ign_library_path "${CMAKE_BINARY_DIR}/src/cmd/cmdtransport${PROJECT_MAJOR_VERSION}")

# Generate a configuration file for internal testing.
# Note that the major version of the library is included in the name.
# Ex: transport0.yaml
configure_file(
  "transport.yaml.in"
    "${CMAKE_BINARY_DIR}/test/conf/transport${PROJECT_MAJOR_VERSION}.yaml" @ONLY)

set(ign_library_path "${CMAKE_INSTALL_PREFIX}/lib/ruby/ignition/cmdtransport${PROJECT_MAJOR_VERSION}")

# Generate a configuration file.
# Note that the major version of the library is included in the name.
# Ex: transport0.yaml
configure_file(
  "transport.yaml.in"
    "${CMAKE_CURRENT_BINARY_DIR}/transport${PROJECT_MAJOR_VERSION}.yaml" @ONLY)

# Install the yaml configuration files in an unversioned location.
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/transport${PROJECT_MAJOR_VERSION}.yaml DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATAROOTDIR}/ignition/)

=== example/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8 FATAL_ERROR)

# Find the Ignition_Transport library
find_package(ignition-transport1 QUIET REQUIRED)
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${IGNITION-TRANSPORT_CXX_FLAGS}")
include_directories(${IGNITION-TRANSPORT_INCLUDE_DIRS})
link_directories(${IGNITION-TRANSPORT_LIBRARY_DIRS})

# Message generation
add_subdirectory(msgs)
set_source_files_properties(${PROTO_SRC} ${PROTO_HEADER}
                            PROPERTIES GENERATED TRUE)
include_directories(${CMAKE_BINARY_DIR})

# Generate examples
add_executable(publisher publisher.cc ${PROTO_SRC})
target_link_libraries(publisher ${IGNITION-TRANSPORT_LIBRARIES})
add_dependencies(publisher protobuf_compilation)

add_executable(subscriber subscriber.cc ${PROTO_SRC})
target_link_libraries(subscriber ${IGNITION-TRANSPORT_LIBRARIES})
add_dependencies(subscriber protobuf_compilation)

add_executable(responser responser.cc ${PROTO_SRC})
target_link_libraries(responser ${IGNITION-TRANSPORT_LIBRARIES})
add_dependencies(responser protobuf_compilation)

add_executable(requester requester.cc ${PROTO_SRC})
target_link_libraries(requester ${IGNITION-TRANSPORT_LIBRARIES})
add_dependencies(requester protobuf_compilation)

add_executable(requester_async requester_async.cc ${PROTO_SRC})
target_link_libraries(requester_async ${IGNITION-TRANSPORT_LIBRARIES})
add_dependencies(requester_async protobuf_compilation)

if (MSVC)
  # Suppress Protobuf message generation warnings.
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4018 /wd4100 /wd4127 /wd4244 /wd4267 /wd4512")

  # Suppress the "decorated name length exceed" warning (inside the STL).
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4503")

  set(BUILD_SHARED_LIBS FALSE)
  add_definitions(-DBUILDING_STATIC_LIBS -DWIN32_LEAN_AND_MEAN)

  # Don't pull in the Windows min/max macros
  add_definitions(-DNOMINMAX)

  # Copy the ZMQ DLLs.
  add_custom_command(TARGET publisher POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy_if_different
    "${ZeroMQ_ROOT_DIR}/bin/libzmq-v120-mt-3_2_4.dll"
    $<TARGET_FILE_DIR:publisher> VERBATIM)

  add_custom_command(TARGET publisher POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy_if_different
    "${ZeroMQ_ROOT_DIR}/bin/libzmq-v120-mt-gd-3_2_4.dll"
    $<TARGET_FILE_DIR:publisher> VERBATIM)
endif()

=== msgs/CMakeLists.txt ===
PROTOBUF_GENERATE_CPP(PROTO_SRC PROTO_HEADER
  int.proto
  vector3d.proto
)

# Variables needed to propagate through modules
# If more than one layer of cmake use CACHE INTERNAL ...
#set (PROTO_SRCS_VAR ${PROTO_SRCS} CACHE INTERNAL "Sources variable")
set(PROTOBUF_INCLUDE_DIRS ${PROTOBUF_INCLUDE_DIRS} PARENT_SCOPE)
set(PROTOBUF_LIBRARIES ${PROTOBUF_LIBRARIES} PARENT_SCOPE)
set(PROTO_SRC ${PROTO_SRC} PARENT_SCOPE)
set(PROTO_HEADER ${PROTO_HEADER} PARENT_SCOPE)

add_custom_target(protobuf_compilation DEPENDS ${PROTO_SRC})

=== src/CMakeLists.txt ===
include (${project_cmake_dir}/Utils.cmake)

set (sources
  AdvertiseOptions.cc
  Discovery.cc
  Helpers.cc
  ign.cc
  NetUtils.cc
  Node.cc
  NodeOptions.cc
  NodeShared.cc
  Packet.cc
  Publisher.cc
  TopicUtils.cc
  Uuid.cc
)

set (gtest_sources
  AdvertiseOptions_TEST.cc
  Discovery_TEST.cc
  Helpers_TEST.cc
  HandlerStorage_TEST.cc
  NetUtils_TEST.cc
  Node_TEST.cc
  NodeOptions_TEST.cc
  Packet_TEST.cc
  Publisher_TEST.cc
  TopicStorage_TEST.cc
  TopicUtils_TEST.cc
  Uuid_TEST.cc
)

set_source_files_properties(${PROTO_SRC} ${PROTO_HEADER} PROPERTIES
                            GENERATED TRUE)
include_directories(${CMAKE_BINARY_DIR}/)
include_directories(${CMAKE_BINARY_DIR}/test/)

ign_build_tests(${gtest_sources})

if (UNIX)
  ign_add_library(${PROJECT_NAME_LOWER}${PROJECT_MAJOR_VERSION} ${sources})
elseif(WIN32)
  # Probotuf compilation is recommended and configured for a STATIC .lib
  # Not mixing static and shared and just build ignition transport as STATIC
  # on Windows
  add_library(${PROJECT_NAME_LOWER}${PROJECT_MAJOR_VERSION} STATIC ${sources})
endif()

# Protobuf module does not have LIBRARIES but LIBRARY
message("ZeroMQ_LIBRARIES: ${ZeroMQ_LIBRARIES}")
target_link_libraries(${PROJECT_NAME_LOWER}${PROJECT_MAJOR_VERSION}
                      ${ZeroMQ_LIBRARIES}
                      ${uuid_LIBRARIES})

if(WIN32)
  target_link_libraries(${PROJECT_NAME_LOWER}${PROJECT_MAJOR_VERSION} ws2_32 Iphlpapi
			optimized
			    ${PROTOBUF_LIBRARY}
			    ${PROTOBUF_PROTOC_LIBRARY}
			debug
			    ${PROTOBUF_LIBRARY_DEBUG}
			    ${PROTOBUF_PROTOC_LIBRARY_DEBUG})
else()
  target_link_libraries(${PROJECT_NAME_LOWER}${PROJECT_MAJOR_VERSION}
                        ${PROTOBUF_LIBRARY})
endif()

ign_install_library(${PROJECT_NAME_LOWER}${PROJECT_MAJOR_VERSION})

add_subdirectory(cmd)

=== src/cmd/CMakeLists.txt ===
include (${project_cmake_dir}/Utils.cmake)

# Generate a the ruby script.
# Note that the major version of the library is included in the name.
# Ex: cmdtransport0.rb
if (APPLE)
  set(IGN_LIBRARY_NAME lib${PROJECT_NAME_LOWER}${PROJECT_MAJOR_VERSION}.dylib)
else()
  set(IGN_LIBRARY_NAME lib${PROJECT_NAME_LOWER}${PROJECT_MAJOR_VERSION}.so)
endif()
configure_file(
  "cmdtransport.rb.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmdtransport${PROJECT_MAJOR_VERSION}.rb" @ONLY)


# Install the ruby command line library in an unversioned location.
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/cmdtransport${PROJECT_MAJOR_VERSION}.rb DESTINATION lib/ruby/ignition)

=== test/integration/CMakeLists.txt ===
set(TEST_TYPE "INTEGRATION")

set(tests
  scopedTopic.cc
  twoProcessesPubSub.cc
  twoProcessesSrvCall.cc
  twoProcessesSrvCallStress.cc
  twoProcessesSrvCallSync1.cc
)

include_directories(SYSTEM ${CMAKE_BINARY_DIR}/test/)
link_directories(${PROJECT_BINARY_DIR}/test)

ign_build_tests(${tests})

# Skip auxiliary files in the test suite
set(IGN_SKIP_IN_TESTSUITE True)

set(auxiliary_files
  fastPub_aux.cc
  scopedTopicSubscriber_aux.cc
  twoProcessesPublisher_aux.cc
  twoProcessesPubSubSubscriber_aux.cc
  twoProcessesSrvCallReplier_aux.cc
  twoProcessesSrvCallReplierIncreasing_aux.cc
)

ign_build_tests(${auxiliary_files})

=== include/ignition/transport/CMakeLists.txt ===
include (${project_cmake_dir}/Utils.cmake)

set (headers
  AdvertiseOptions.hh
  Discovery.hh
  HandlerStorage.hh
  Helpers.hh
  ign.hh
  NetUtils.hh
  Node.hh
  NodeOptions.hh
  NodeShared.hh
  Packet.hh
  Publisher.hh
  RepHandler.hh
  ReqHandler.hh
  SubscriptionHandler.hh
  TopicStorage.hh
  TopicUtils.hh
  TransportTypes.hh
  Uuid.hh
)

#################################################
### Do not change the following

set (ign_headers "" CACHE INTERNAL "Ignition headers" FORCE)
foreach (hdr ${headers})
  APPEND_TO_CACHED_STRING(ign_headers
    "Ignition headers" "#include <ignition/${IGN_PROJECT_NAME}/${hdr}>\n")
endforeach()

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/ign_auto_headers.hh.in
                ${CMAKE_CURRENT_BINARY_DIR}/${IGN_PROJECT_NAME}.hh)

ign_install_includes("${IGN_PROJECT_NAME}${PROJECT_MAJOR_VERSION}/ignition"
                     ${CMAKE_CURRENT_BINARY_DIR}/${IGN_PROJECT_NAME}.hh)
ign_install_includes("${IGN_PROJECT_NAME}${PROJECT_MAJOR_VERSION}/ignition/${IGN_PROJECT_NAME}"
                     ${headers})

=== debian/changelog ===
ignition-transport (1.3.0-5) unstable; urgency=medium

  * Fix use system gtest patch
    (Closes: #844878)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Mon, 28 Nov 2016 11:44:19 +0000

ignition-transport (1.3.0-4) unstable; urgency=medium

  * Fix pkgconfig file. Ignition transport 1.x series does not use ignition-msgs
   (Closes: #836384)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Sat, 10 Sep 2016 14:43:28 +0000

ignition-transport (1.3.0-3) unstable; urgency=medium

  * Added patch for pkgconfig file
   (Closes: #836384)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Tue, 06 Sep 2016 21:22:27 +0000

ignition-transport (1.3.0-2) unstable; urgency=medium

  * Fix compilation for protobuf3
    (Closes: #835429)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Tue, 30 Aug 2016 23:41:05 +0000

ignition-transport (1.3.0-1) unstable; urgency=medium

  [ Jose Luis Rivero ]
  * Remove old transitional package
  * Include all versions of ignition-transport cmake modules
  * Update standards version
  * Imported Upstream version 1.3.0 (Closes: #789379)
  * Do not use Node for testing but Uuid
  * Imported Upstream version 1.2.0

  [ Anton Gladky ]
  * Drop -dbg package

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Mon, 25 Jul 2016 16:58:56 +0000

=== debian/control ===
Source: ignition-transport
Standards-Version: 3.9.8
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Jose Luis Rivero <jrivero@osrfoundation.org>
Section: science
Priority: extra
Testsuite: autopkgtest
Build-Depends: cmake,
               pkg-config,
               debhelper (>= 9),
               python,
               ruby-ronn,
               libgtest-dev,
               libprotoc-dev,
               libprotobuf-dev,
               protobuf-compiler,
               uuid-dev,
               libzmq3-dev (>= 3.0.0)
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/ignition-transport.git
Vcs-Git: git://anonscm.debian.org/debian-science/packages/ignition-transport.git
Homepage: http://ignitionrobotics.org/libraries/transport

Package: libignition-transport1
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ignition Robotics Transport Library - Shared library
 Ignition transport library combines ZeroMQ with Protobufs to create a fast and
 efficient message passing system. Asynchronous message publication and
 subscription is provided along with service calls and discovery.
 .
 Ignition Robtics is a set of simple libraries that provide useful
 functionality to bootstrap robot applications. The included libraries
 encapsulate all the essentials, such as common math data types, console
 logging, 3D mesh management, and asynchronous message passing.

Package: libignition-transport-dev
Architecture: any
Section: libdevel
Depends: libignition-transport1 (= ${binary:Version}),
         uuid-dev,
         libzmq3-dev (>= 3.0.0),
         libprotobuf-dev,
         ${misc:Depends}
Breaks: libignition-transport0-dev (<< 1.0.0)
Replaces: libignition-transport-dev (<< 1.0.0)
Multi-Arch: same
Description: Ignition Robotics transport Library - Development files
 Ignition transport library combines ZeroMQ with Protobufs to create a fast and
 efficient message passing system. Asynchronous message publication and
 subscription is provided along with service calls and discovery.
 .
 Ignition Robtics is a set of simple libraries that provide useful
 functionality to bootstrap robot applications. The included libraries
 encapsulate all the essentials, such as common math data types, console
 logging, 3D mesh management, and asynchronous message passing.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

.PHONY: override_dh_auto_configure \
        override_dh_auto_test \
        override_dh_strip 

override_dh_auto_configure:
	dh_auto_configure -- \
                -DUSE_HOST_CFLAGS:BOOL=False \
                -DUSE_UPSTREAM_CFLAGS:BOOL=False \
                -DCMAKE_BUILD_TYPE=RelWithDebInfo

override_dh_auto_test:
	# Test are using networking heavily, disabled
	# since they can not run on the buil farm
	true

%:
	dh $@ --parallel --buildsystem=cmake

## ignition-transport 4.0.0%2Bdfsg

=== test/regression/CMakeLists.txt ===
set(TEST_TYPE "REGRESSION")

ign_get_sources(tests)

ign_build_tests(TYPE REGRESSION SOURCES ${tests})

if(TARGET REGRESSION_deprecated)
  # Turn off deprecation warnings specifically for the test of deprecated
  # functions.
  if(UNIX)
    target_compile_options(REGRESSION_deprecated PRIVATE -Wno-deprecated-declarations)
  elseif(MSVC)
    target_compile_options(REGRESSION_deprecated PRIVATE /wd4996)
  endif()
endif()

## ignition-transport 4.0.0+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.1 FATAL_ERROR)

#============================================================================
# Initialize the project
#============================================================================
project(ignition-transport4 VERSION 4.0.0)

#============================================================================
# Find ignition-cmake
#============================================================================
# If you get an error at this line, you need to install ignition-cmake
find_package(ignition-cmake0 0.4.0 REQUIRED)

#============================================================================
# Configure the project
#============================================================================
ign_configure_project()

#============================================================================
# Set project-specific options
#============================================================================

# ignition-transport currently has no options that are unique to it

#============================================================================
# Search for project-specific dependencies
#============================================================================
message(STATUS "\n\n-- ====== Finding Dependencies ======")

#--------------------------------------
# Find Protobuf
if(MSVC)
  # On Windows we require version 3+ in order to have proper support for
  # shared libraries.
  set(REQ_PROTOBUF_VER 3)
  set(PROTOBUF_PURPOSE "Windows requires version 3+ to ensure proper support for DLLs")
else()
  set(REQ_PROTOBUF_VER 2.3.0)
  set(PROTOBUF_PURPOSE)
endif()
ign_find_package(IgnProtobuf
                 VERSION ${REQ_PROTOBUF_VER}
                 REQUIRED
                 PRETTY Protobuf
                 PURPOSE ${PROTOBUF_PURPOSE})

#--------------------------------------
# Find ZeroMQ
ign_find_package(ZeroMQ VERSION 4 REQUIRED PRIVATE)

#--------------------------------------
# Find cppzmq
ign_find_package(CPPZMQ REQUIRED PRIVATE
  PKGCONFIG_IGNORE # NOTE: cppzmq does not seem to offer a pkg-config file
  PRETTY CppZMQ)

#--------------------------------------
# Find uuid
if (MSVC)
  message (STATUS "UUID: Using Windows RPC UuidCreate function\n")
else()
  ign_find_package(UUID REQUIRED)
endif()

#--------------------------------------
# Find ignition-msgs
set(IGN_MSGS_VER 1)
ign_find_package(ignition-msgs${IGN_MSGS_VER} REQUIRED)

#--------------------------------------
# Find ifaddrs
ign_find_package(IFADDRS QUIET)
if (IFADDRS_FOUND)
  set (HAVE_IFADDRS ON CACHE BOOL "HAVE IFADDRS" FORCE)
else ()
  set (HAVE_IFADDRS OFF CACHE BOOL "HAVE IFADDRS" FORCE)
endif()

#--------------------------------------
# Find ignition-tools
ign_find_package(ignition-tools QUIET)

#============================================================================
# Configure the build
#============================================================================
ign_configure_build(QUIT_IF_BUILD_ERRORS)

#============================================================================
# ign command line support
#============================================================================
add_subdirectory(conf)

#============================================================================
# Test the command line commands
#============================================================================
add_subdirectory(tools)

#============================================================================
# Create package information
#============================================================================
ign_create_packages()

=== conf/CMakeLists.txt ===
# Used only for internal testing.
set(ign_library_path "${CMAKE_BINARY_DIR}/test/lib/ruby/ignition/cmdtransport${PROJECT_VERSION_MAJOR}")

# Generate a configuration file for internal testing.
# Note that the major version of the library is included in the name.
# Ex: transport0.yaml
configure_file(
  "transport.yaml.in"
    "${CMAKE_BINARY_DIR}/test/conf/transport${PROJECT_VERSION_MAJOR}.yaml" @ONLY)

# Used for the installed version.
set(ign_library_path "${CMAKE_INSTALL_PREFIX}/lib/ruby/ignition/cmdtransport${PROJECT_VERSION_MAJOR}")

# Generate the configuration file that is installed.
# Note that the major version of the library is included in the name.
# Ex: transport0.yaml
configure_file(
  "transport.yaml.in"
    "${CMAKE_CURRENT_BINARY_DIR}/transport${PROJECT_VERSION_MAJOR}.yaml" @ONLY)

# Install the yaml configuration files in an unversioned location.
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/transport${PROJECT_VERSION_MAJOR}.yaml DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATAROOTDIR}/ignition/)

=== doc/CMakeLists.txt ===
find_package(Doxygen)

set(IGNITION_DOXYGEN_TAGFILES
  "\"${IGNITION-MSGS_DOXYGEN_TAGFILE} = ${IGNITION-MSGS_API_URL}\"")

if (DOXYGEN_FOUND)
  configure_file(${IGNITION_CMAKE_DOXYGEN_DIR}/api.in
                 ${CMAKE_BINARY_DIR}/api.dox @ONLY)

  configure_file(${IGNITION_CMAKE_DOXYGEN_DIR}/tutorials.in
                 ${CMAKE_BINARY_DIR}/tutorials.dox @ONLY)

  add_custom_target(doc ALL
    # Generate the API documentation
    ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/api.dox
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}

    COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/tutorials.dox

    COMMENT "Generating API documentation with Doxygen" VERBATIM)

  install(FILES ${CMAKE_BINARY_DIR}/doc/${PROJECT_NAME_LOWER}.tag.xml 
    DESTINATION ${CMAKE_INSTALL_PREFIX}/share/ignition/${PROJECT_NAME_LOWER}_${PROJECT_VERSION_MINOR})
endif()

=== example/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8 FATAL_ERROR)

# Find the Ignition_Transport library
find_package(ignition-transport4 QUIET REQUIRED)
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${IGNITION-TRANSPORT_CXX_FLAGS}")
include_directories(${IGNITION-TRANSPORT_INCLUDE_DIRS})
link_directories(${IGNITION-TRANSPORT_LIBRARY_DIRS})

# Message generation. Only required when using custom Protobuf messages.
find_package(Protobuf REQUIRED)
add_subdirectory(msgs)
set_source_files_properties(${PROTO_SRC} ${PROTO_HEADER}
                            PROPERTIES GENERATED TRUE)
include_directories(${CMAKE_BINARY_DIR})

# Generate examples
if (EXISTS "${CMAKE_SOURCE_DIR}/bench.cc")
  ########################################
  # GFlags
  find_library(gflags_LIBRARIES NAMES gflags)
  find_path(gflags_INCLUDE_DIRS gflags/gflags.h ENV CPATH)
  if (NOT gflags_LIBRARIES OR NOT gflags_INCLUDE_DIRS)
    message (STATUS "Unable to compile 'bench.cc', missing GFLags library")
  else()
    include_directories(SYSTEM ${gflags_INCLUDE_DIRS})
    add_executable(bench bench.cc)
    target_link_libraries(bench ${IGNITION-TRANSPORT_LIBRARIES}
                          ${gflags_LIBRARIES})
  endif()
endif()

if (EXISTS "${CMAKE_SOURCE_DIR}/publisher.cc")
  add_executable(publisher publisher.cc)
  target_link_libraries(publisher ${IGNITION-TRANSPORT_LIBRARIES})
endif()

if (EXISTS "${CMAKE_SOURCE_DIR}/subscriber.cc")
  add_executable(subscriber subscriber.cc)
  target_link_libraries(subscriber ${IGNITION-TRANSPORT_LIBRARIES})
endif()

if (EXISTS "${CMAKE_SOURCE_DIR}/subscriber_generic.cc")
  add_executable(subscriber_generic subscriber_generic.cc)
  target_link_libraries(subscriber_generic ${IGNITION-TRANSPORT_LIBRARIES})
endif()

if (EXISTS "${CMAKE_SOURCE_DIR}/responser.cc")
  add_executable(responser responser.cc)
  target_link_libraries(responser ${IGNITION-TRANSPORT_LIBRARIES})
endif()

if (EXISTS "${CMAKE_SOURCE_DIR}/requester.cc")
  add_executable(requester requester.cc)
  target_link_libraries(requester ${IGNITION-TRANSPORT_LIBRARIES})
endif()

if (EXISTS "${CMAKE_SOURCE_DIR}/requester_async.cc")
  add_executable(requester_async requester_async.cc)
  target_link_libraries(requester_async ${IGNITION-TRANSPORT_LIBRARIES})
endif()

if (EXISTS "${CMAKE_SOURCE_DIR}/responser_oneway.cc")
  add_executable(responser_oneway responser_oneway.cc)
  target_link_libraries(responser_oneway ${IGNITION-TRANSPORT_LIBRARIES})
endif()

if (EXISTS "${CMAKE_SOURCE_DIR}/requester_oneway.cc")
  add_executable(requester_oneway requester_oneway.cc)
  target_link_libraries(requester_oneway ${IGNITION-TRANSPORT_LIBRARIES})
endif()

if (EXISTS "${CMAKE_SOURCE_DIR}/responser_no_input.cc")
  add_executable(responser_no_input responser_no_input.cc)
  target_link_libraries(responser_no_input ${IGNITION-TRANSPORT_LIBRARIES})
endif()

if (EXISTS "${CMAKE_SOURCE_DIR}/requester_no_input.cc")
  add_executable(requester_no_input requester_no_input.cc)
  target_link_libraries(requester_no_input ${IGNITION-TRANSPORT_LIBRARIES})
endif()

if (EXISTS "${CMAKE_SOURCE_DIR}/requester_async_no_input.cc")
  add_executable(requester_async_no_input requester_async_no_input.cc)
  target_link_libraries(requester_async_no_input ${IGNITION-TRANSPORT_LIBRARIES})
endif()

if (EXISTS "${CMAKE_SOURCE_DIR}/publisher_custom_msg.cc")
  add_executable(publisher_custom_msg publisher_custom_msg.cc)
  target_link_libraries(publisher_custom_msg
     ${IGNITION-TRANSPORT_LIBRARIES}
     ${PROTO_SRC}
  )
  add_dependencies(publisher_custom_msg protobuf_compilation)
endif()

if (EXISTS "${CMAKE_SOURCE_DIR}/subscriber_custom_msg.cc")
  add_executable(subscriber_custom_msg subscriber_custom_msg.cc)
  target_link_libraries(subscriber_custom_msg
    ${IGNITION-TRANSPORT_LIBRARIES}
    ${PROTO_SRC}
  )
  add_dependencies(subscriber_custom_msg protobuf_compilation)
endif()

if (EXISTS "${CMAKE_SOURCE_DIR}/publisher_raw.cc")
  add_executable(publisher_raw publisher_raw.cc)
  target_link_libraries(publisher_raw ${IGNITION-TRANSPORT_LIBRARIES})
endif()

if (EXISTS "${CMAKE_SOURCE_DIR}/subscriber_raw.cc")
  add_executable(subscriber_raw subscriber_raw.cc)
  target_link_libraries(subscriber_raw ${IGNITION-TRANSPORT_LIBRARIES})
endif()


if (MSVC)
  # Suppress Protobuf message generation warnings.
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4018 /wd4100 /wd4127 /wd4244 /wd4267 /wd4512")

  # Suppress the "decorated name length exceed" warning (inside the STL).
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4503")

  set(BUILD_SHARED_LIBS FALSE)
  add_definitions(-DBUILDING_STATIC_LIBS -DWIN32_LEAN_AND_MEAN)

  # Don't pull in the Windows min/max macros
  add_definitions(-DNOMINMAX)

  # Copy the ZMQ DLLs.
  add_custom_command(TARGET publisher POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy_if_different
    "${ZeroMQ_ROOT_DIR}/bin/libzmq-v120-mt-4_0_4.dll"
    $<TARGET_FILE_DIR:publisher> VERBATIM)

  add_custom_command(TARGET publisher POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy_if_different
    "${ZeroMQ_ROOT_DIR}/bin/libzmq-v120-mt-gd-4_0_4.dll"
    $<TARGET_FILE_DIR:publisher> VERBATIM)

  # Copy the Ignition Messages DLL.
  add_custom_command(TARGET publisher POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy_if_different
    "${IGNITION-MSGS_FOLDER}/lib/ignition-msgs0.dll"
    $<TARGET_FILE_DIR:publisher> VERBATIM)

endif()

=== src/CMakeLists.txt ===
# Collect source files into the "sources" variable and unit test files into the
# "gtest_sources" variable.
ign_get_libsources_and_unittests(sources gtest_sources)

# Create the library target.
ign_add_library(${PROJECT_LIBRARY_TARGET_NAME} ${sources})

# Turn on C++14 support for the library.
ign_set_project_public_cxx_standard(14)

# Link the libraries that we always need.
target_link_libraries(${PROJECT_LIBRARY_TARGET_NAME}
  PUBLIC
    ignition-msgs${IGN_MSGS_VER}::ignition-msgs${IGN_MSGS_VER}
  PRIVATE
    ${ZeroMQ_TARGET}
    CPPZMQ::CPPZMQ
)

# Windows system library provides UUID
if (NOT MSVC)
  target_link_libraries(${PROJECT_LIBRARY_TARGET_NAME}
    PUBLIC
      UUID::UUID
  )
endif()

# Create installation instructions for the library target. This must be called
# in the same scope that the target is created.
ign_install_library()

# Build the unit tests.
ign_build_tests(TYPE UNIT SOURCES ${gtest_sources})

if(MSVC)
  # On Windows, UNIT_Discovery_TEST uses some socket functions and therefore
  # needs to link to the Windows socket library. An easy, maintainable way to
  # do that is to tell it to link to the ZeroMQ target, and let it get the
  # socket library dependency transitively.
  if(TARGET UNIT_Discovery_TEST)
    target_link_libraries(UNIT_Discovery_TEST
      ${ZeroMQ_TARGET})
  endif()
endif()

# Command line support.
add_subdirectory(cmd)

=== tools/CMakeLists.txt ===
include_directories(
  ${CMAKE_BINARY_DIR}
  ${CMAKE_BINARY_DIR}/test
)

set (test_sources
  ign_TEST.cc
)

if (IGNITION-TOOLS_BINARY_DIRS)
  ign_build_tests(TYPE UNIT SOURCES ${test_sources})
endif ()

=== src/cmd/CMakeLists.txt ===
# Set the library name.
if (APPLE)
  set(IGN_LIB_BASENAME lib${PROJECT_NAME_LOWER}.dylib)
else()
  set(IGN_LIB_BASENAME lib${PROJECT_NAME_LOWER}.so)
endif()

# Used only for internal testing.
set(IGN_LIBRARY_NAME ../../../../src/${IGN_LIB_BASENAME})

# Generate the ruby script for internal testing.
# Note that the major version of the library is included in the name.
# Ex: cmdtransport0.rb
configure_file(
  "cmdtransport.rb.in"
    "${CMAKE_BINARY_DIR}/test/lib/ruby/ignition/cmdtransport${PROJECT_VERSION_MAJOR}.rb" @ONLY)

# Used for the installed version.
#
# Specify the library path relative to the location of the .rb script.
# E.g.: cmdtransport3.rb is installed in:
#   /home/caguero/local/lib/ruby/ignition/cmdtransport3.rb
# The Ignition Transport library is installed in:
#   /home/caguero/local/lib/libignition-transport3.so
# The value of IGN_LIBRARY_NAME should be:
#   ../../libignition-transport3.so
set(IGN_LIBRARY_NAME ../../../${CMAKE_INSTALL_LIBDIR}/${IGN_LIB_BASENAME})

# Generate the ruby script that is installed.
# Note that the major version of the library is included in the name.
# Ex: cmdtransport0.rb
configure_file(
  "cmdtransport.rb.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmdtransport${PROJECT_VERSION_MAJOR}.rb" @ONLY)

# Install the ruby command line library in an unversioned location.
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/cmdtransport${PROJECT_VERSION_MAJOR}.rb DESTINATION lib/ruby/ignition)

=== test/integration/CMakeLists.txt ===
set(TEST_TYPE "INTEGRATION")

set(tests
  authPubSub.cc
  scopedTopic.cc
  twoProcessesPubSub.cc
  twoProcessesSrvCall.cc
  twoProcessesSrvCallStress.cc
  twoProcessesSrvCallSync1.cc
  twoProcessesSrvCallWithoutInput.cc
  twoProcessesSrvCallWithoutInputStress.cc
  twoProcessesSrvCallWithoutInputSync1.cc
  twoProcessesSrvCallWithoutOutput.cc
  twoProcessesSrvCallWithoutOutputStress.cc
)

ign_build_tests(TYPE INTEGRATION SOURCES ${tests})

set(auxiliary_files
  authPubSubSubscriberInvalid_aux
  fastPub_aux
  pub_aux
  pub_aux_throttled
  scopedTopicSubscriber_aux
  twoProcessesPublisher_aux
  twoProcessesPubSubSubscriber_aux
  twoProcessesSrvCallReplier_aux
  twoProcessesSrvCallReplierIncreasing_aux
  twoProcessesSrvCallWithoutInputReplier_aux
  twoProcessesSrvCallWithoutInputReplierIncreasing_aux
  twoProcessesSrvCallWithoutOutputReplier_aux
  twoProcessesSrvCallWithoutOutputReplierIncreasing_aux
)

# Build the auxiliary files.
foreach(AUX_EXECUTABLE ${auxiliary_files})
  ign_add_executable(INTEGRATION_${AUX_EXECUTABLE} ${AUX_EXECUTABLE}.cc)

  # Include the interface directories that we always need.
  ign_target_interface_include_directories(INTEGRATION_${AUX_EXECUTABLE}
    ${PROJECT_LIBRARY_TARGET_NAME})

  # Link the libraries that we always need.
  target_link_libraries(INTEGRATION_${AUX_EXECUTABLE}
    PRIVATE
      ${PROJECT_LIBRARY_TARGET_NAME}
      gtest
  )

  if(UNIX)
    # pthread is only available on Unix machines
    target_link_libraries(INTEGRATION_${AUX_EXECUTABLE}
      PRIVATE pthread)
  endif()

endforeach(AUX_EXECUTABLE)

=== test/performance/CMakeLists.txt ===
set(TEST_TYPE "PERFORMANCE")

set(tests
)

ign_build_tests(TYPE PERFORMANCE SOURCES ${tests})

=== include/ignition/transport/CMakeLists.txt ===
# All private headers won't be installed.
set (private_headers
  NodeOptionsPrivate.hh
  NodePrivate.hh
  SubscribeOptionsPrivate.hh
)

ign_install_all_headers(EXCLUDE ${private_headers})

=== debian/changelog ===
ignition-transport (4.0.0+dfsg-4ubuntu1) focal; urgency=medium

  * Build using python2.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 31 Mar 2020 14:50:59 +0200

ignition-transport (4.0.0+dfsg-4build2) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:16:24 +0100

ignition-transport (4.0.0+dfsg-4build1) disco; urgency=medium

  * No-change rebuild against latest protobuf

 -- Jeremy Bicha <jbicha@ubuntu.com>  Sat, 10 Nov 2018 15:42:21 -0500

ignition-transport (4.0.0+dfsg-4) unstable; urgency=medium

  * Include the missing the yaml file to fix current broken ign-tools support

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 09 Mar 2018 17:24:48 +0000

ignition-transport (4.0.0+dfsg-3) unstable; urgency=medium

  * Fix conflict with self -dev package

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Thu, 08 Mar 2018 23:01:16 +0000

ignition-transport (4.0.0+dfsg-2) unstable; urgency=medium

  * Include the ign-tools ruby module into the packaging
    (Closes: #892378)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Thu, 08 Mar 2018 15:47:09 +0000

ignition-transport (4.0.0+dfsg-1) unstable; urgency=medium

  [ Jose Luis Rivero ]
  * New upstream version 4.0.0+dfsg
    (Closes: #883757)
    (Closes: #888017)

  [ Anton Gladky ]
  * Switch to compat-level 11
  * Set Standards-Version: 4.1.3
  * Update VCS-fields (move to salsa)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Mon, 05 Feb 2018 14:04:13 +0000

=== debian/control ===
Source: ignition-transport
Standards-Version: 4.1.3
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Jose Luis Rivero <jrivero@osrfoundation.org>
Section: science
Priority: optional
Build-Depends: cmake,
               pkg-config,
               debhelper (>= 11),
               python2,
               ruby-ronn,
               libgtest-dev,
               libprotoc-dev,
               libprotobuf-dev,
               protobuf-compiler,
               uuid-dev,
               libzmq3-dev (>= 3.0.0),
               libignition-msgs-dev (>= 1.0.0+dfsg1-3),
               libignition-cmake-dev (>= 0.4.0)
Vcs-Browser: https://salsa.debian.org/science-team/ignition-transport
Vcs-Git: https://salsa.debian.org/science-team/ignition-transport.git
Homepage: https://ignitionrobotics.org/libs/transport

Package: libignition-transport4
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ignition Robotics Transport Library - Shared library
 Ignition transport library combines ZeroMQ with Protobufs to create a fast and
 efficient message passing system. Asynchronous message publication and
 subscription is provided along with service calls and discovery.
 .
 Ignition Robtics is a set of simple libraries that provide useful
 functionality to bootstrap robot applications. The included libraries
 encapsulate all the essentials, such as common math data types, console
 logging, 3D mesh management, and asynchronous message passing.
 .
 The package ships the ignition transport libraries

Package: libignition-transport-dev
Depends: libignition-transport4-dev, ${misc:Depends}
Architecture: all
Priority: optional
Section: oldlibs
Description: transitional package
 This is a transitional package to migrate to version 4-dev. This should help
 to preparate user system to host collide installation of 4 and future versions.

Package: libignition-transport4-dev
Architecture: any
Section: libdevel
Depends: libignition-transport4 (= ${binary:Version}),
         uuid-dev,
         libzmq3-dev (>= 3.0.0),
         libprotobuf-dev,
         libignition-msgs-dev,
         libignition-cmake-dev (>= 0.4.0),
         ${misc:Depends}
Replaces: libignition-transport-dev
Multi-Arch: same
Description: Ignition Robotics transport Library - Development files
 Ignition transport library combines ZeroMQ with Protobufs to create a fast and
 efficient message passing system. Asynchronous message publication and
 subscription is provided along with service calls and discovery.
 .
 Ignition Robtics is a set of simple libraries that provide useful
 functionality to bootstrap robot applications. The included libraries
 encapsulate all the essentials, such as common math data types, console
 logging, 3D mesh management, and asynchronous message passing.
 .
 The package ships the ignition transport development headers and libraries

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

.PHONY: override_dh_auto_configure \
        override_dh_auto_test

override_dh_auto_configure:
	dh_auto_configure -- \
                -DUSE_HOST_CFLAGS:BOOL=False \
                -DUSE_UPSTREAM_CFLAGS:BOOL=False \
                -DCMAKE_BUILD_TYPE=RelWithDebInfo

override_dh_auto_test:
	# Test are using networking heavily, disabled
	# since they can not run on the build farm
	true

# Upstream release page is generated dynamically taking long time
get-orig-source:
	uscan --timeout 90 --verbose --force-download --repack --compress xz

%:
	dh $@ --parallel --buildsystem=cmake

=== debian/watch ===
version=3
opts=uversionmangle=s/$/+dfsg/ \
 http://gazebosim.org/distributions/ign-transport/releases/ .*ignition-transport4-(\d\.\d\.\d)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
